global srcDir = (getDir #temp) + @"\RenderBuzz"
global srcScriptFile = srcDir + @"\RenderBuzz.mse"
global srcRBAssemblyFile = srcDir + @"\RenderBuzz.dll"
global srcZipAssemblyFile = srcDir + @"\DotNetZip.dll"
global srcNewtonsoftJsonAssemblyFile = srcDir + @"\Newtonsoft.Json.dll"

global srcDirUI = (getDir #temp) + @"\RenderBuzz\UI"
global srcPackageContentFile = srcDirUI + @"\PackageContents.xml"

global srcDirUIScripts = (getDir #temp) + @"\RenderBuzz\UI\pre_startup_scripts"
global srcMenuScriptFile = srcDirUIScripts + @"\menu-renderbuzz.ms"


global destDir = (getdir #userscripts) + @"\RenderBuzz"
global destScriptFile = destDir + @"\RenderBuzz.mse"
global destRBAssemblyFile = destDir + @"\RenderBuzz.dll"
global destZipAssemblyFile = destDir + @"\DotNetZip.dll"
global destDataFile = destDir + @"\RenderBuzz.dat"
global destNewtonsoftJsonAssemblyFile = destDir + @"\Newtonsoft.Json.dll"

global destDirUI = (getdir #privateExchangeStoreInstallPath) + @"\RenderBuzz"
global destPackageContentFile = destDirUI + @"\PackageContents.xml"

global destDirUIScripts = (getdir #privateExchangeStoreInstallPath) + @"\RenderBuzz\pre_startup_scripts"
global destMenuScriptFile = destDirUIScripts + @"\menu-renderbuzz.ms"

try(destroyDialog RBInstallerRollout)catch()
rollout RBInstallerRollout "RenderBuzz Uploader Plugin Installer" width:360 height:100
(
	button InstallBtn "Install RenderBuzz Uploader Plugin" width: 350 height:50
	button RemoveBtn "Uninstall RenderBuzz Uploader Plugin" width: 350 height:30

	function addNewRenderBuzzMenu = 
	(
		-- add RenderBuzz Plugin to menu
		filein ((getdir #privateExchangeStoreInstallPath) + @"\RenderBuzz\pre_startup_scripts\menu-renderbuzz.ms")

 		-- update menuBar
		iCuiMenuMgr = maxops.GetICuiMenuMgr()
		iCuiMenuMgr.LoadConfiguration (iCuiMenuMgr.GetCurrentConfiguration())
		iCuiMenuMgr.SetCurrentConfiguration (iCuiMenuMgr.GetCurrentConfiguration())
	)

	function removeNewRenderBuzzMenu = 
	(
		try (
			callbacks.removeScripts id:#menuRenderBuzz
			iCuiMenuMgr = maxops.GetICuiMenuMgr()
			iCuiMenuMgr.LoadConfiguration (iCuiMenuMgr.GetCurrentConfiguration())
			iCuiMenuMgr.SetCurrentConfiguration (iCuiMenuMgr.GetCurrentConfiguration())
		)
		catch()
	)
	
	function addRenderBuzzMenu =
	(
		macroScript RenderBuzz category:"RenderBuzz"
		(
			filein ((getdir #userscripts) + @"\RenderBuzz\RenderBuzz.mse")
		)

		-- create separate menu
		mainMenu = menuMan.getMainMenuBar() 
		rbMenu = menuMan.createMenu "RenderBuzz" 
		rbSubMenu = menuMan.createSubMenuItem "RenderBuzz Uploader Plugin" rbMenu 
		mainMenu.addItem rbSubMenu (mainMenu.numItems()+1)
		
		-- add button to RenderBuzz menu
		action = menuMan.createActionItem "RenderBuzz" "RenderBuzz"
		action.setUseCustomTitle true
		action.setTitle "Render with RenderBuzz..."
		rbMenu.addItem action (rbMenu.numItems()+1) 
		
		-- create button in Rendering Menu
		renderingMenu = menuMan.findMenu "&Rendering"
		renderingMenu.addItem action 2
		
		menuMan.updateMenuBar()
	)

	function removeRenderBuzzMenu =
	(
		try(
			toolsMenu = menuMan.getMainMenuBar()
			toolsMenuCount = toolsMenu.numItems()

			for i = 1 to toolsMenuCount do
			(
				fileMenu = (toolsMenu.getItem i).getTitle()
				if fileMenu == "RenderBuzz" do
				(
					toolsMenu.removeItemByPosition i
					menuMan.updateMenuBar()
				)
			)
			
			renderingMenu = menuMan.findMenu "&Rendering"
			for i = renderingMenu.numItems() to 1 by -1 do
			(
				menuTitle = (renderingMenu.getItem i).getTitle()
				if menuTitle == "Render with RenderBuzz..." do
				(
					renderingMenu.removeItemByPosition i
					menuMan.updateMenuBar()
				)
			)
		)catch()
	)

	function removeFiles =
	(
		hiddenDOSCommand ("del \"" + destScriptFile + "\"")
		hiddenDOSCommand ("del \"" + destRBAssemblyFile + "\"")
		hiddenDOSCommand ("del \"" + destZipAssemblyFile + "\"")
		hiddenDOSCommand ("del \"" + destNewtonsoftJsonAssemblyFile + "\"")
		
		hiddenDOSCommand ("del \"" + destPackageContentFile + "\"")
		hiddenDOSCommand ("del \"" + destMenuScriptFile + "\"")
	)

	function removeData = 
	(
		hiddenDOSCommand ("del \"" + destDataFile + "\"")
	)
	
	function installFiles =
	(
		--tempDir = ((getdir #temp) + @"\" + "RenderBuzz" + @"\" ) -- CHANGE THIS LINE TO MATCH FUTURE FOLDER NAMES
		
		makeDir destDir
		copyScript = stringstream ""
		format "copy \"%\" \"%\" /Y" srcScriptFile destScriptFile to:copyScript
		
		copyRBAssemblyCMD = stringstream ""
		format "copy \"%\" \"%\" /Y" srcRBAssemblyFile destRBAssemblyFile to:copyRBAssemblyCMD

		copyZipAssemblyCMD = stringstream ""
		format "copy \"%\" \"%\" /Y" srcZipAssemblyFile destZipAssemblyFile to:copyZipAssemblyCMD		
		
		copyNewtonsoftJsonAssemblyCMD = stringstream ""
		format "copy \"%\" \"%\" /Y" srcNewtonsoftJsonAssemblyFile destNewtonsoftJsonAssemblyFile to:copyNewtonsoftJsonAssemblyCMD
		
		makeDir destDirUI
		copyPackageContentCMD = stringstream ""
		format "copy \"%\" \"%\" /Y" srcPackageContentFile destPackageContentFile to:copyPackageContentCMD

		makeDir destDirUIScripts
		copyMenuScriptCMD = stringstream ""
		format "copy \"%\" \"%\" /Y" srcMenuScriptFile destMenuScriptFile to:copyMenuScriptCMD

		
		--copyAssembly = ("xcopy "\" + tempDir + "RenderBuzz.dll" + "\"" + " " + "\"" + (getDir #userscripts) + @"\RenderBuzz" + "\""  + " /E")
		--copyAssembly = ("xcopy " + "\"" + tempDir + "RenderBuzz.dll" + "\"" + " " + "\"" + (getDir #assemblies) + @"\" + "\""  + " /E")
		
		hiddenDOSCommand copyScript
		hiddenDOSCommand copyRBAssemblyCMD
		hiddenDOSCommand copyZipAssemblyCMD
		hiddenDOSCommand copyNewtonsoftJsonAssemblyCMD

		hiddenDOSCommand copyPackageContentCMD
		hiddenDOSCommand copyMenuScriptCMD
		
		--dotNet.loadAssembly "#assemblies\RenderBuzz.dll"
		dotNet.loadAssembly srcRBAssemblyFile
		dotNet.loadAssembly srcZipAssemblyFile
		dotNet.loadAssembly srcNewtonsoftJsonAssemblyFile
	)
	
	function removeAll = 
	(
		if (dotNetClass "RenderBuzz.Request") != undefined do (
			throw "Restart 3ds Max before proceed"
		)		
		removeFiles()
		ver = maxversion()
		if (ver[1] >= 27000) then 
		(
			removeNewRenderBuzzMenu()
		)
		else 
		(
			removeRenderBuzzMenu()
		)
	)
	
	on RBInstallerRollout open do (
		clearlistener()
	)
	
	on InstallBtn pressed do 
	(
		ver = maxversion()
		try (
			removeAll()
			installFiles()
			if (ver[1] >= 27000) then 
			(
				addNewRenderBuzzMenu()
			)
			else 
			(
				addRenderBuzzMenu()
			)			
			messagebox ("RenderBuzz Upload Plugin has been installed successfully!")
			destroyDialog RBInstallerRollout
			filein destScriptFile
		) catch (
			messagebox (getCurrentException())
		)
	)
	
	on RemoveBtn pressed do
	(
		try (
			removeAll()
			removeData()
			messagebox ("RenderBuzz Upload Plugin has been removed successfully.")
			destroyDialog RBInstallerRollout
		) catch (
			messagebox (getCurrentException())
		)
	)
	
)

createDialog RBInstallerRollout
